﻿;https://masm32.com/board/index.php?topic=470.0
XIncludeFile "GMP.pbi"
; Structure mpf_struct
;     _mp_prec.l
;     _mp_size.l
;     _mp_exp.l
;     _mp_d.l
; EndStructure
; 
; 
; ImportC "gmp.lib"
;   gmpf_init2(var.l,prec.l) As "___gmpf_init2"
;   gmpf_set_str(var.l,s$,num.l) As "___gmpf_init_set_str"
;   gmpf_sqrt(a.l,b.l) As "___gmpf_sqrt"
;   gmpf_ui_div(v_b.l, b1.l, v_c.l) As "___gmpf_ui_div"
;   gmpf_add(A.l, sa.l, sb.l) As "___gmpf_add"
;   gmpf_div_ui(A0.l,A1.l, d.l) As "___gmpf_div_ui"
;   gmpf_mul(B.l,va.l,vb.l) As "___gmpf_mul"
;   gmpf_sub(T.l,va.l,A.l) As "___gmpf_sub"
;   gmpf_pow_ui(T0.l,T1.l,p.l) As "___gmpf_pow_ui"
;   gmpf_mul_ui(Pb.l,ps.l, n.l) As "___gmpf_mul_ui"
;   gmpf_swap(sa.l,BA.l) As "___gmpf_swap"
;   gmpf_div(d.l, d1.l, d2.l) As "___gmpf_div"
;   gmp_sprintf(*buf, fmt$,va.l) As "___gmp_sprintf"
; EndImport
PIDIGITS = 1000
;mp_exp_t  TYPEDEF DWORD
;mp_limb_t TYPEDEF DWORD

    va.mpf;_struct
    vb.mpf;_struct
    vt.mpf;_struct
    vp.mpf;_struct
    A.mpf;_struct
    B.mpf;_struct
    T.mpf;_struct
    P.mpf;_struct
    Pi.mpf;_struct
;==============================================================================

    If PIDIGITS = 1000
        PRECISION = 3297+10
    ElseIf PIDIGITS = 100000
        PRECISION = 332193+10
    ElseIf PIDIGITS = 1000000
        PRECISION = 3321921+10
    Else
      Debug "ERROR PIDIGITS MUST BE 1000, 100000, Or 1000000"
      End
    EndIf

;     For var,<a,b,t,p,A,B,T,P,Pi>
;         invoke __gmpf_init2, ADDR var, PRECISION
;     ENDM
    mpf_init2(@va,PRECISION)
    mpf_init2(@vb,PRECISION)
    mpf_init2(@vt,PRECISION)
    mpf_init2(@vp,PRECISION)
    mpf_init2(@A,PRECISION)
    mpf_init2(@B,PRECISION)
    mpf_init2(@T,PRECISION)
    mpf_init2(@P,PRECISION)
    mpf_init2(@Pi,PRECISION)

    ;invoke __gmpf_set_str, ADDR a, chr$("1.0"),10
    mpf_set_str(@va,"1.0",10)
    ;invoke __gmpf_set_str, ADDR b, chr$("2.0"),10
    mpf_set_str(@vb,"2.0",10)
    ;invoke __gmpf_set_str, ADDR t, chr$("0.25"),10
    mpf_set_str(@vt,"0.25",10)
    ;invoke __gmpf_set_str, ADDR p, chr$("1.0"),10
    mpf_set_str(@vp,"1.0",10)
    ;invoke __gmpf_sqrt, ADDR b, ADDR b
    mpf_sqrt(@vb,@vb)
    ;invoke __gmpf_ui_div, ADDR b, 1, ADDR b
    mpf_ui_div(@vb,1,@vb)
    ;invoke __gmp_printf, cfm$("%.20Ff\n"), ADDR b ; should be 0.707106781...


    If PIDIGITS =1000
        rebx=10;mov ebx, 10
    ElseIf PIDIGITS =100000
        rebx=17;mov ebx, 17
    ElseIf PIDIGITS =1000000
        rebx=20;mov ebx, 20
    EndIf

    *m=AllocateMemory(PIDIGITS+10)
    ;gmp_sprintf(*m, "%.20Ff",@vb)
    ;Debug PeekS(*m,PIDIGITS)
    
For i=1 To rebx
    ;-------------
    ; A = (a+b)/2
    ;-------------

    ;invoke __gmpf_add, ADDR A, ADDR a, ADDR b
    mpf_add(@A,@va,@vb)
    ;invoke __gmpf_div_ui, ADDR A, ADDR A, 2
    mpf_div_ui(@A,@A, 2)

    ;---------------
    ; B = sqrt(a*b)
    ;---------------

    ;invoke __gmpf_mul, ADDR B, ADDR a, ADDR b
    mpf_mul(@B,@va,@vb)
    ;invoke __gmpf_sqrt, ADDR B, ADDR B
    mpf_sqrt(@B,@B)

    ;-----------------
    ; T = t-p*(a-A)^2
    ;-----------------

    ;invoke __gmpf_sub, ADDR T, ADDR a, ADDR A
    mpf_sub(@T,@va,@A)
    ;invoke __gmpf_pow_ui, ADDR T, ADDR T, 2
    mpf_pow_ui(@T,@T, 2)
    ;invoke __gmpf_mul, ADDR T, ADDR T, ADDR p
    mpf_mul(@T,@T,@vp)
    ;invoke __gmpf_sub, ADDR T, ADDR t, ADDR T
    mpf_sub(@T,@vt,@T)

    ;---------
    ; P = 2*p
    ;---------

    ;invoke __gmpf_mul_ui, ADDR P, ADDR p, 2
    mpf_mul_ui(@P,@vp, 2)

    ;----------------------------
    ; a = A, b = B, t = T, p = P
    ;----------------------------

    ;invoke __gmpf_swap, ADDR a, ADDR A
    mpf_swap(@va,@A)
    ;invoke __gmpf_swap, ADDR b, ADDR B
    mpf_swap(@vb,@B)
    ;invoke __gmpf_swap, ADDR t, ADDR T
    mpf_swap(@vt,@T)
    ;invoke __gmpf_swap, ADDR p, ADDR P
    mpf_swap(@vp,@P)

;     sub ebx, 1
;     jnz @B
  Next i

    ;-------------------
    ; Pi ~= (a+b)^2/4*t
    ;-------------------

    ;invoke __gmpf_add, ADDR Pi, ADDR a, ADDR b
  mpf_add(@Pi,@va,@vb)
    ;invoke __gmpf_pow_ui, ADDR Pi, ADDR Pi, 2
    mpf_pow_ui(@Pi,@Pi, 2)
    ;invoke __gmpf_div_ui, ADDR Pi, ADDR Pi, 4
    mpf_div_ui(@Pi,@Pi, 4)
    ;invoke __gmpf_div, ADDR Pi, ADDR Pi, ADDR t
    mpf_div(@Pi,@Pi,@vt)
    
    If PIDIGITS =1000
      ;invoke __gmp_printf, cfm$("%.1000Ff\n\n"), ADDR Pi;gmp_sprintf(*buf, *fmt)
      f$="%.1000Ff"
      gmp_sprintf(*m, @f$,@Pi)
    ElseIf PIDIGITS = 100000
      ;  invoke __gmp_printf, cfm$("%.100000Ff\n\n"), ADDR Pi
      f$="%.10000Ff"
      gmp_sprintf(*m, @f$,@Pi)
    ElseIf PIDIGITS =1000000
      ;  invoke __gmp_printf, cfm$("%.1000000Ff\n\n"), ADDR Pi
      f$="%.100000Ff"
      gmp_sprintf(*m, @f$,@Pi)
    EndIf
    
    Debug PeekS(*m,-1,#PB_Ascii)
;     invoke GetTickCount
;     pop edx
;     sub eax, edx
;     printf("%dms\n\n", eax)
; 
;     inkey
;     exit
;==============================================================================
; End start
; 
; These from http://gc3.net84.net/pi.htm
; 
; Last 40 digits of 1000:
; 1712268066 1300192787 6611195909 2164201989
; Last 40 digits of 100000:
; 7728658035 7127909137 6742080565 5493624646
; Last 40 digits of 1000000:
; 3311646283 9963464604 2209010610 5779458151
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 174
; FirstLine = 144
; EnableXP