﻿Structure mpz
  mp_alloc.l
  mp_size.l
  mp_limb.l
EndStructure

Structure mpf
  mp_prec.i
  mp_size.i 
  mp_expt.i 
  mp_limb.i 
EndStructure

ImportC "libgmp-3.lib"
  
  mpf_set_default_prec(prec.i) As "___gmpf_set_default_prec"
  mpf_init(*x.mpf) As "___gmpf_init"
  mpf_sqrt_ui(*rop.mpf, op.i) As "___gmpf_sqrt_ui"
  mpf_get_str(*str, *expptr, base.i, n_digits.i, *op.mpf) As "___gmpf_get_str"
  mpf_clear(*x.mpf) As "___gmpf_clear"
EndImport

result.mpf;mpf_t result; // floating point variable
;char *output; // holds the output result string
 exp.l;mp_exp_t exp; // holds the exponent for the result string
 
 *output=AllocateMemory(10000)
 
    mpf_set_default_prec(1024); // set default precision in bits

    mpf_init(@result); // allocate and init variable

    mpf_sqrt_ui(@result, 2); // compute sqrt(2)

 ;   // convert To string, And print:
    mpf_get_str(*output, @exp, 10, 0, @result);
                                                  ;   printf("%.*s.%s\n", (int)exp, output, output+exp);
                                                  ;ShowMemoryViewer(*output,1024)
    r$=PeekS(*output,-1,#PB_Ascii)

Debug Mid(r$,1,exp)+"."+Mid(r$,exp+1)
;    // clean up
    FreeMemory(*output);     // mpf_get_str() calls malloc()
    mpf_clear(@result);

; 1.4142135623730950488016887242096980785696718753769480731766797379907
; 324784621070388503875343276415727350138462309122970249248360558507372
; 126441214970999358314132226659275055927557999505011527820605714701095
; 599716059702745345968620147285174186408891986095523292304843087143214
; 50839762603627995251407989687253396

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 40
; FirstLine = 32
; EnableXP